
#property copyright "fx777"
#property link      "fxtrader777"

#property indicator_separate_window
//#property indicator_minimum -100
//#property indicator_maximum 100
#property indicator_buffers 5
#property indicator_color1 Blue
#property indicator_color2 Red
extern int FasterMA = 21;
extern int SlowerMA = 50;
extern int SlowestMA= 70;
 bool ShowHistory=true;
extern bool WaitForBarClose=true;
extern bool ShowInWindow=true;
extern color HistoryColor=Yellow;
string historyline[15000];
bool l12bigger=false;
double distance, prevdistance;
//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   //SetIndexDrawBegin(0,0);
   
   SetIndexBuffer(1,ExtMapBuffer2);
   //SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
  // SetIndexStyle(2,DRAW_LINE);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
      int ii;
      for(ii=15000; ii>=0; ii--){ObjectDelete("historyline"+ii);}
      Comment("");
      return;
  }
//---- 
   
//----
  
  

double DistanceEqual(double line1, double line2, double line3, bool alert, int i){
   double dist1to2=MathAbs(line1-line2);
   double dist2to3=MathAbs(line2-line3);
   double distdiff;
   
   ExtMapBuffer1[i]=dist1to2/Point;
   ExtMapBuffer2[i]=dist2to3/Point;
   
   distdiff=dist1to2-dist2to3;
   
   return(distdiff);
  
   
 
   
      
  

      

}





 
 
int start()
  {
   Comment("Equal distance between MA lines by fxt777");
   int    counted_bars=IndicatorCounted();
 
//---- check for possible errors
   if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   
   int pos=(Bars-counted_bars)-1;
  
  // datetime timepos;
     
 
   while(pos>=0)
     {
         
         
       
       
         ExtMapBuffer3[pos]= iMA(NULL,0,FasterMA,0,MODE_EMA,PRICE_CLOSE,pos);

         ExtMapBuffer4[pos]= iMA(NULL,0,SlowerMA,0,MODE_EMA,PRICE_CLOSE,pos);
         
         ExtMapBuffer5[pos]= iMA(NULL,0,SlowestMA,0,MODE_EMA, PRICE_CLOSE,pos);
         
         distance=DistanceEqual(ExtMapBuffer3[pos],ExtMapBuffer4[pos], ExtMapBuffer5[pos], false, pos);
        
         //ExtMapBuffer1[pos]=distance/Point;
         //Alert(ExtMapBuffer1[pos]," ", Point);
         if ((distance*prevdistance)<0){
            if(ShowInWindow){
                historyline[pos]="historyline"+pos;
                ObjectCreate(historyline[pos], OBJ_TREND, 0, Time[pos], MathMin(MathMin(ExtMapBuffer3[pos], ExtMapBuffer5[pos]),ExtMapBuffer4[pos]),  Time[pos], MathMax(MathMax(ExtMapBuffer5[pos],ExtMapBuffer3[pos]),ExtMapBuffer4[pos]));
                ObjectSet (historyline[pos], OBJPROP_COLOR, HistoryColor);
                ObjectSet (historyline[pos], OBJPROP_RAY, 0);
            }    
               if (pos==WaitForBarClose){
               
                  Alert("There has been equal distance between the MA lines");
               
               }
         }
         prevdistance=distance;
        
        
         pos--;
         
     }
     
     
     
     //DistanceEqual(ExtMapBuffer1[0],ExtMapBuffer2[0], ExtMapBuffer3[0], true, 0);
     //Print(DistanceEqual (ExtMapBuffer1[0],ExtMapBuffer2[0], ExtMapBuffer3[0]);
     //Print("Hello");


//----
   return(0);
  }
//+------------------------------------------------------------------+